<?php
/*
* Is.php - Check if a player is online.
*
* BeBot - An Anarchy Online Chat Automaton
* Copyright (C) 2004 Jonas Jax
* Copyright (C) 2005-2007 Thomas Juberg Stensås, ShadowRealm Creations and the BeBot development team.
*
* Developed by:
* - Alreadythere (RK2)
* - Blondengy (RK1)
* - Blueeagl3 (RK1)
* - Glarawyn (RK1)
* - Khalem (RK1)
* - Naturalistic (RK1)
*
* See Credits file for all aknowledgements.
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; version 2 of the License only.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
*  USA
*
* File last changed at $LastChangedDate: 2007-07-25 21:09:30 +0200 (Wed, 25 Jul 2007) $
* Revision: $Id: Is.php 818 2007-07-25 19:09:30Z shadowmaster $
*/

$is = new Is($bot);

$commands["tell"]["is"] = &$is;
$commands["gc"]["is"] = &$is;
$commands["pgmsg"]["is"] = &$is;

$commands["buddy"][] = &$is;
$cron["5sec"][] = &$is;



/*
The Class itself...
*/
class Is
{
	var $bot;
	var $query;



	/*
	Constructor:
	Hands over a referance to the "Bot" class.
	*/
	function Is (&$bot)
	{
		$this -> bot = &$bot;

        $this -> bot -> settings -> create ("Is", "Errormsg", TRUE, "Display error message on invalid username? (Turning this off is reccomended when you are not using a command prefix.)", "On;Off", FALSE, 5);
		$this -> bot -> settings -> create ("Is", "CheckAlts", TRUE, "Should Alts be Checked?");

		$this -> bot -> accesscontrol -> create('all', 'is', 'GUEST');

		$this -> help['description'] = 'Shows online status for a player.';
		$this -> help['command']['is <name>']="Shows if player <name> is online or offline";
		
		$this -> ready = time() + 10;
	}


	/*
	This gets called on a tell with the command
	*/
	function tell($name, $msg)
	{
		$reply = $this -> is_online ($name, $msg, "tell");
		if ($reply !== FALSE)
			$this -> bot -> send_tell($name, $reply);
	}


	/*
	This gets called on a msg in the guildchat with the command
	*/
	function gc($name, $msg)
	{
		$reply = $this -> is_online ($name, $msg, "gc");
		if ($reply !== FALSE)
			$this -> bot -> send_gc($reply);
	}


	/*
	This gets called on a msg in the guildchat with the command
	*/
	function pgmsg($name, $msg)
	{
		$reply = $this -> is_online ($name, $msg, "pgroup");
		if ($reply !== FALSE)
			$this -> bot -> send_pgroup($reply);
	}


	/*
	Handles the acutally online/offline code
	*/
	function is_online ($name, $msg, $origin)
	{
		if ($this -> ready > time())
		{
			$left = $this -> ready - time();
			Return "Bot not Ready (".$left." more secs)";
		}
		// Trim whitespace off the end of the message before regexp.
		// This will make sure "Name " as well as "Name" matches.
		$msg = rtrim($msg);
		if(!preg_match("/^" . $this -> bot -> commpre . "is ([a-zA-Z0-9]{4,25})$/i", $msg, $info))
		{
			if ($this -> bot -> settings -> get("Is", "Errormsg"))
			{
				Return ("Please enter a valid name.");
			}
			else
			{
				Return FALSE;
			}
		}
		else
		{
			$info[1] = ucfirst(strtolower($info[1]));

			if (!$this -> bot -> aoc -> get_uid($info[1]))
				Return("Player " . $info[1] . " does not exist.");
			else if ($info[1] == ucfirst(strtolower($this -> bot -> botname)))
				Return("I'm online!");
			else if ($info[1] == $name)
				Return("Your Asking me if You are Online?");
			else if (!empty($this -> query))
				Return("<pre>is module is Currently Busy Please Try again in a sec");
			elseif ($this -> bot -> settings -> get("Is", "Checkalts"))
			{
				$main = $this -> bot -> alts -> main($info[1]);
				$alts = $this -> bot -> alts -> get_alts($main);
				if ($this -> bot -> aoc -> buddy_exists($main))
				{
					if ($this -> bot -> aoc -> buddy_online($main))
					{
						$this -> online[$info[1]][] = $main;
					}
				}
				else
				{
					$this -> query[$main] = array ($origin, $name, $info[1], time());
					$buddy_add[] = $main;
				}
				if (!empty($alts))
					foreach ($alts as $alt)
					{
						if ($this -> bot -> aoc -> buddy_exists($alt))
						{
							if ($this -> bot -> aoc -> buddy_online($alt))
							{
								$this -> online[$info[1]][] = $alt;
							}
						}
						else
						{
							$this -> query[$alt] = array ($origin, $name, $info[1], time());
							$buddy_add[] = $alt;
						}
					}
				if (!empty($buddy_add))
				{
					foreach ($buddy_add as $buddy)
						$this -> bot -> aoc -> buddy_add($buddy);
				}
				else
					$this -> send($name, $info[1], $origin);
			}
			else
			{
				if ($this -> bot -> aoc -> buddy_exists($info[1]))
				{
					if ($this -> bot -> aoc -> buddy_online($info[1]))
						$this -> online[$info[1]][] = $info[1];
					$this -> send($name, $info[1], $origin);
				}
				else
				{
					$this -> query[$info[1]] = array ($origin, $name, $info[1], time());
					$this -> bot -> aoc -> buddy_add($info[1]);
				}
			}
		}
		Return FALSE;
	}



	function last_seen($name)
	{
		$seen = $this -> bot -> online -> get_last_seen($name, $this -> bot -> settings -> get("Is", "Checkalts"));
		if ($seen)
		{
			if ($this -> bot -> settings -> get("Is", "Checkalts"))
				$msg = ", last seen at ##highlight##" . gmdate($this -> bot -> settings -> get("Time", "FormatString"), $seen[0]) . "##end## on ##highlight##".$seen[1]."##end##";
			else
				$msg = ", last seen at ##highlight##" . gmdate($this -> bot -> settings -> get("Time", "FormatString"), $seen) . "##end##";
		}
		return $msg;
	}
	/*
	This gets called if a buddy logs on/off
	*/
	function buddy($name, $msg)
	{
		if (!$this -> bot -> notify -> check($name))
		{
			if (isset($this -> query[$name]))
			{
				if ($msg == 1)
					$this -> online[$this -> query[$name][2]][] = $name;
				$name2 = $this -> query[$name][1];
				$origin = $this -> query[$name][0];
				$target = $this -> query[$name][2];
				unset($this -> query[$name]);
				
				if (empty($this -> query))
					$this -> send($name2, $target, $origin);
			}
		}
	}

	function send($name, $target, $origin)
	{
		$msg1 = $target . " is ##red##offline##end##";
		if (!empty($this -> online[$target]))
		{
			foreach ($this -> online[$target] as $online)
			{
				if ($online == $target)
					$msg1 = $online . " is ##lime##online##end##";
				else
					$msg2 .= ", " . $online . " is ##lime##online##end##";
			}
			unset($this -> online[$target]);
		}
		else
			$msg1 .= $this -> last_seen($target);
		$this -> bot -> send_output($name, $msg1.$msg2, $origin);
	}

	function cron()
	{
		if(!empty($this -> query))
			foreach($this -> query as $check)
				if($check[3] < time() - 10 && !$sent)
				{
					$sent = TRUE;
					$this -> bot -> send_output($check[1], "<pre>is Process was Canceled (timeout)", $check[0]);
					unset($this -> query);
					unset($this -> online);
				}
	}
}
?>