<?php
/*
* Is.php - Check if a player is online.
*
* BeBot - An Anarchy Online Chat Automaton
* Copyright (C) 2004 Jonas Jax
* Copyright (C) 2005-2007 Thomas Juberg Stensås, ShadowRealm Creations and the BeBot development team.
*
* Developed by:
* - Alreadythere (RK2)
* - Blondengy (RK1)
* - Blueeagl3 (RK1)
* - Glarawyn (RK1)
* - Khalem (RK1)
* - Naturalistic (RK1)
*
* See Credits file for all aknowledgements.
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; version 2 of the License only.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
*  USA
*
* File last changed at $LastChangedDate: 2007-07-25 21:09:30 +0200 (Wed, 25 Jul 2007) $
* Revision: $Id: Is.php 818 2007-07-25 19:09:30Z shadowmaster $
*/

$is = new Is($bot);

$commands["tell"]["is"] = &$is;
$commands["gc"]["is"] = &$is;
$commands["pgmsg"]["is"] = &$is;

$commands["buddy"][] = &$is;




/*
The Class itself...
*/
class Is
{
	var $bot;
	var $query;



	/*
	Constructor:
	Hands over a referance to the "Bot" class.
	*/
	function Is (&$bot)
	{
		$this -> bot = &$bot;

        $this -> bot -> settings -> create ("Is", "Errormsg", TRUE, "Display error message on invalid username? (Turning this off is reccomended when you are not using a command prefix.)", "On;Off", FALSE, 5);
		
		$this -> bot -> accesscontrol -> create('tell', 'is', 'GUEST');
		$this -> bot -> accesscontrol -> create('gc', 'is', 'GUEST');
		$this -> bot -> accesscontrol -> create('pgmsg', 'is', 'GUEST');

		$this -> help['description'] = 'Shows online status for a player.';
		$this -> help['command']['is <name>']="Shows if player <name> is online or offline";
	}



	/*
	This gets called on a tell with the command
	*/
	function tell($name, $msg)
	{
		$this -> is_online ($name, $msg);
	}



	/*
	This gets called on a msg in the guildchat with the command
	*/
	function gc($name, $msg)
	{
		$this -> is_online ("gc", $msg);
	}



	/*
	This gets called on a msg in the guildchat with the command
	*/
	function pgmsg($name, $msg)
	{
		$this -> is_online ("pgroup", $msg);
	}



	/*
	Handles the acutally online/offline code
	*/
	function is_online ($where, $msg)
	{
		// Trim whitespace off the end of the message before regexp.
		// This will make sure "Name " as well as "Name" matches. 
		$msg = rtrim($msg); 		
		if(!preg_match("/^" . $this -> bot -> commpre . "is ([a-zA-Z0-9]{4,25})$/i", $msg, $info))
		{
            if ($this -> bot -> settings -> get("Is", "Errormsg"))
            {
			    $msg = "Please enter a valid name.";
            }
            else
            {
                $msg = NULL;
            }
		}
		else
		{
			$info[1] = ucfirst(strtolower($info[1]));
			$msg = "";

			if (!$this -> bot -> aoc -> get_uid($info[1]))
			$msg = "Player " . $info[1] . " does not exist.";
			else if ($info[1] == ucfirst(strtolower($this -> bot -> botname)))
			$msg = "I'm online!";
			else if ($this -> bot -> aoc -> buddy_exists($info[1]))
			{
				if ($this -> bot -> aoc -> buddy_online($info[1]))
				$msg = $info[1] . " is ##lime##online##end##";
				else
				{
					$msg = $info[1] . " is ##red##offline##end##";
					$msg .= $this -> last_seen($info[1]);
				}
			}
			else
			{
				$this -> query[$info[1]] = $where;
				$this -> bot -> aoc -> buddy_add($info[1]);
			}
		}

		if (!empty($msg) && $where == "gc")
		$this -> bot -> send_gc($msg);
		else if (!empty($msg) && $where == "pgroup")
		$this -> bot -> send_pgroup($msg);
		else if (!empty($msg))
		$this -> bot -> send_tell($where, $msg);
	}



	function last_seen($name)
	{
		if ($this -> bot -> online -> get_last_seen($name))
		{
			return ", last seen at ##highlight##" . gmdate($this -> bot -> settings -> get("Time", "FormatString"), $this -> bot -> online -> get_last_seen($name)) . "##end##";
		}
		return "";
	}
	/*
	This gets called if a buddy logs on/off
	*/
	function buddy($name, $msg)
	{
		if (!$this -> bot -> notify -> check($name))
		{
			if (isset($this -> query[$name]))
			{
				if ($msg == 1)
				{
					$msg =  $name . " is ##lime##online##end##";
				}
				else
				{
					$msg = $name . " is ##red##offline##end##";
					$msg .= $this -> last_seen($name);
				}

				if (!empty($msg) && ($this -> query[$name] == "gc"))
				$this -> bot -> send_gc($msg);
				else if (!empty($msg) && ($this -> query[$name] == "pgroup"))
				$this -> bot -> send_pgroup($msg);
				else if (!empty($msg))
				$this -> bot -> send_tell($this -> query[$name], $msg);

				unset($this -> query[$name]);
			}
		}
	}
}
?>
